diff --git a/gnu/local.mk b/gnu/local.mk
index c721718301..8f1e37f356 100644
--- a/gnu/local.mk
+++ b/gnu/local.mk
@@ -1870,7 +1870,6 @@ dist_patch_DATA =						\
   %D%/packages/patches/tao-fix-parser-types.patch		\
   %D%/packages/patches/tar-remove-wholesparse-check.patch	\
   %D%/packages/patches/tar-skip-unreliable-tests.patch		\
-  %D%/packages/patches/tbb-fix-test-on-aarch64.patch		\
   %D%/packages/patches/tbb-other-arches.patch			\
   %D%/packages/patches/tclxml-3.2-install.patch			\
   %D%/packages/patches/tcsh-fix-autotest.patch			\
diff --git a/gnu/packages/patches/tbb-fix-test-on-aarch64.patch b/gnu/packages/patches/tbb-fix-test-on-aarch64.patch
deleted file mode 100644
index 3a6003591e..0000000000
--- a/gnu/packages/patches/tbb-fix-test-on-aarch64.patch
+++ /dev/null
@@ -1,35 +0,0 @@
-From 013035b4e9af39f506e87ae6b755c3363e768d4d Mon Sep 17 00:00:00 2001
-From: Vladislav Shchapov <phprus@gmail.com>
-Date: Thu, 23 Dec 2021 19:17:24 +0500
-Subject: [PATCH] Fix issue #687 (test_eh_thread) (#697)
-
-Signed-off-by: Vladislav Shchapov <phprus@gmail.com>
----
- test/tbb/test_eh_thread.cpp | 4 +++-
- 1 file changed, 3 insertions(+), 1 deletion(-)
-
-diff --git a/test/tbb/test_eh_thread.cpp b/test/tbb/test_eh_thread.cpp
-index aa6d764d..af291f48 100644
---- a/test/tbb/test_eh_thread.cpp
-+++ b/test/tbb/test_eh_thread.cpp
-@@ -36,6 +36,7 @@
- // TODO: enable limitThreads with sanitizer under docker
- #if TBB_USE_EXCEPTIONS && !_WIN32 && !__ANDROID__
- 
-+#include <limits.h>
- #include <sys/types.h>
- #include <sys/time.h>
- #include <sys/resource.h>
-@@ -73,7 +74,8 @@ public:
-         mValid = false;
-         pthread_attr_t attr;
-         // Limit the stack size not to consume all virtual memory on 32 bit platforms.
--        if (pthread_attr_init(&attr) == 0 && pthread_attr_setstacksize(&attr, 100*1024) == 0) {
-+        std::size_t stacksize = utils::max(128*1024, PTHREAD_STACK_MIN);
-+        if (pthread_attr_init(&attr) == 0 && pthread_attr_setstacksize(&attr, stacksize) == 0) {
-             mValid = pthread_create(&mHandle, &attr, thread_routine, /* arg = */ nullptr) == 0;
-         }
-     }
--- 
-2.34.0
-
diff --git a/gnu/packages/patches/tbb-other-arches.patch b/gnu/packages/patches/tbb-other-arches.patch
index b649eb3eb8..0ebfde165c 100644
--- a/gnu/packages/patches/tbb-other-arches.patch
+++ b/gnu/packages/patches/tbb-other-arches.patch
@@ -1,8 +1,8 @@
 diff --git a/src/tbb/tools_api/ittnotify_config.h b/src/tbb/tools_api/ittnotify_config.h
-index 8ecc2378..0cf26f85 100644
+index f904a8e9..405f92e6 100644
 --- a/src/tbb/tools_api/ittnotify_config.h
 +++ b/src/tbb/tools_api/ittnotify_config.h
-@@ -159,6 +159,11 @@
+@@ -163,6 +163,11 @@
  #  define ITT_ARCH_ARM64  6
  #endif /* ITT_ARCH_ARM64 */
  
@@ -14,7 +14,7 @@ index 8ecc2378..0cf26f85 100644
  #ifndef ITT_ARCH
  #  if defined _M_IX86 || defined __i386__
  #    define ITT_ARCH ITT_ARCH_IA32
-@@ -172,6 +177,8 @@
+@@ -176,6 +181,8 @@
  #    define ITT_ARCH ITT_ARCH_ARM64
  #  elif defined __powerpc64__
  #    define ITT_ARCH ITT_ARCH_PPC64
@@ -24,7 +24,7 @@ index 8ecc2378..0cf26f85 100644
  #endif
  
 diff --git a/test/CMakeLists.txt b/test/CMakeLists.txt
-index 9534dce8..51a79331 100644
+index 2aa669c9..f915e252 100644
 --- a/test/CMakeLists.txt
 +++ b/test/CMakeLists.txt
 @@ -387,7 +387,10 @@ if (TARGET TBB::tbb)
diff --git a/gnu/packages/tbb.scm b/gnu/packages/tbb.scm
index d8c7d59c8d..4ce7c1cf49 100644
--- a/gnu/packages/tbb.scm
+++ b/gnu/packages/tbb.scm
@@ -32,7 +32,7 @@ (define-module (gnu packages tbb)
 (define-public tbb
   (package
     (name "tbb")
-    (version "2021.5.0")
+    (version "2021.6.0")
     (source (origin
               (method git-fetch)
               (uri (git-reference
@@ -41,12 +41,8 @@ (define-public tbb
               (file-name (git-file-name name version))
               (sha256
                (base32
-                "1z0pqzfx63zrmyqdvvkk8vl5dc0i0n5cimdkrypd50ig4d4yi7sc"))
-              (patches
-                ;; Backport an upstream commit that prevents the
-                ;; "test_eh_thread" test failing on AArch64.
-                (search-patches "tbb-fix-test-on-aarch64.patch"
-                                "tbb-other-arches.patch"))))
+                "039v4jmnkkxs7haxrfmk9j57vfbrwlhjynlm5byfaqddv4cbsy0p"))
+              (patches (search-patches "tbb-other-arches.patch"))))
     (build-system cmake-build-system)
     (arguments
      `(#:configure-flags '("-DTBB_STRICT=OFF"))) ;; Don't fail on warnings